
.include "vcs.inc"
.include "globals.inc"

.define SOUND 1
.define HEIGHT $7a
.define COLOR0 $0e
.define COLOR1 $2a
.define COLOR2 $9a
.define COLOR3 $58
.define COLOR4 $c8
.define COLOR5 $64
.define COLOR6 $d6
.define COLOR7 $00

.segment "RODATA"

trsi_t:
   .byte %00000000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %11111111
   .byte %11111111

trsi_r:
   .byte %00000000
   .byte %11000011
   .byte %11000011
   .byte %11000110
   .byte %11001100
   .byte %11011000
   .byte %11110000
   .byte %11111110
   .byte %11111110
   .byte %11000011
   .byte %11000011
   .byte %11000011
   .byte %11000011
   .byte %11111110
   .byte %11111110

trsi_s:
   .byte %00000000
   .byte %01111110
   .byte %01111110
   .byte %11000011
   .byte %11000011
   .byte %00000011
   .byte %00000011
   .byte %01111110
   .byte %01111110
   .byte %11000000
   .byte %11000000
   .byte %11000011
   .byte %11000011
   .byte %01111110
   .byte %01111110

trsi_i:
   .byte %00000000
   .byte %11111111
   .byte %11111111
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %00011000
   .byte %11111111
   .byte %11111111

.segment "CODE"

tvcolors:
.if SOUND
   lda #$0c
   sta AUDC0
   lda #$0b
   sta AUDF0
   lda #$03
   sta AUDV0
   lda #$00
   sta AUDV1
.endif
   lda #%01111100
   sta PF1
   asl
   sta PF2
   lda #$00
   sta CTRLPF
   dec framecount
   lda #$00
   ldx framecount
   cpx #$10
   bcs @noflash
   lda paltab,x
@noflash:
   sta COLUP0
   sta COLUP1
   lda #$00
   sta GRP0
   sta GRP1
   lda #$04
   sta NUSIZ0
   sta NUSIZ1
   lda #$1c
   ldx #$00
   jsr spritepos
   lda #$3c
   inx
   jsr spritepos
   
   ldx #HEIGHT
   jsr waitvblank
@loop1:
   sta WSYNC

   lda #COLOR0
   sta COLUBK
   lda #COLOR1
   sta COLUPF
   
   jsr delay12
   and ($80,x)
   
   lda #COLOR2
   sta COLUBK
   lda #COLOR3
   sta COLUPF
   
   and ($80,x)
   
   lda #COLOR4
   sta COLUBK
   lda #COLOR5
   sta COLUPF
  
   lda #COLOR6
   sta COLUBK
   lda #COLOR7
   sta COLUPF
   
   dex
   cpx #<(trsi_r-trsi_t-1)
   bne @loop1
   
@loop2:
   sta WSYNC

   lda #COLOR0
   sta COLUBK
   lda #COLOR1
   sta COLUPF

   ldy trsi_t,x
   sty GRP0
   ldy trsi_r,x
   sty GRP1
   ldy trsi_s,x

   lda #COLOR2
   sta COLUBK
   lda #COLOR3
   sta COLUPF

   sty GRP0

   lda #COLOR4
   sta COLUBK
   lda #COLOR5
   sta COLUPF

   ldy trsi_i,x
   
   lda #COLOR6
   sta COLUBK

   sty GRP1

   lda #COLOR7
   sta COLUPF
   
   dex
   bpl @loop2

@loop3:
   sta WSYNC
   
   lda #COLOR0
   sta COLUBK
   lda #COLOR1
   sta COLUPF
   
   jsr delay12
   and ($80,x)
   
   lda #COLOR2
   sta COLUBK
   lda #COLOR3
   sta COLUPF
   
   and ($80,x)
   
   lda #COLOR4
   sta COLUBK
   lda #COLOR5
   sta COLUPF
  
   lda #COLOR6
   sta COLUBK
   lda #COLOR7
   sta COLUPF
   
   inx
   cpx #HEIGHT
   bne @loop3
   
   sta COLUBK
   
   jsr waitscreen
   
   jmp waitoverscan
   
