
.include "vcs.inc"
.include "globals.inc"

.segment "ZEROPAGE"

.segment "RODATA"

demopartslo:
   .lobytes partsaddrlist
demopartshi:
   .hibytes partsaddrlist

.segment "CODE"

reset:
   cld
   ldx #$ff
   txs
   inx
   txa
   pha
   beq firstrun
   
waitvblank:
   lda #TIMER_SCREEN
@waitloop:
   bit TIMINT
   bpl @waitloop
   sta TIM1KTI
   rts
   
waitscreen:
   lda #TIMER_OVERSCAN
@waitloop:
   bit TIMINT
   bpl @waitloop
   sta TIM64TI
   lda #$02
   sta VBLANK
   rts

waitoverscan:
   lda #TIMER_VBLANK
   pha
   php
   pla
   and #%00000100 ; irq flag
   bne nonext
   inc schedule
   ldx #localramstart+1 ; keep pushed value for TIM64T intact
firstrun:
   sei
@clrloop:
   sta $ff,x
   inx
   bne @clrloop
   
nonext:
@waitloop:
   bit TIMINT
   bpl @waitloop

   lda #%00001110  ; each '1' bits generate a VSYNC ON line (bits 1..3)
@syncloop:
   sta WSYNC
   sta VSYNC       ; 1st '0' bit resets VSYNC, 2nd '0' bit exit loop
   lsr
   bne @syncloop   ; branch until VSYNC has been reset
   sta VBLANK
   sta COLUBK
   pla
   sta TIM64TI

   lda audc2
   bne @noinit
   lda #$6e
   sta audc2
   lda #<song
   ldx #>song
   jsr bytetrackerset
@noinit:
   ldx schedule
   cpx #demopartshi-demopartslo-1
   bcs @nomusic
   jsr bytetracker
@nomusic:
   
   ldx schedule
   lda demopartshi,x
   pha
   lda demopartslo,x
   pha
delay12:
   rts

