
.include "vcs.inc"
.include "globals.inc"

.segment "ZEROPAGE"

loopcount = localramstart + 0
colu      = localramstart + 1
count     = localramstart + 3
lastaudf  = localramstart + 4

.segment "RODATA"

.include "rotabar.inc"

   ;     000;001;010;011;100;101;110;111
offsets:
   .byte $12,$40,$20,$22,$00,$04,$02,$06 ; first byte=$80 turns off

.segment "CODE"

setcol:
   cpy #$0f
   bne @nop0
   sta colu+0
   sta colu+1
   beq @coldonep
@nop0:
   cpy #$08
   bcs @nop1
   sta colu+1
   sbc #$01
   sta colu+0
   bne @coldonep
@nop1:
   sta colu+0
   sbc #$01
   sta colu+1
@coldonep:
   rts

rotabar:
   ldx #$00
   dec framecount
.if 0
   lda framecount
   rol
   rol
   rol
   rol
.else
   lda audf
   eor audv
.if 0
   cmp lastaudf
   sta lastaudf
   beq @nochg
   dec count
@nochg:
   lda count
.endif
.endif
   and #$07
   eor #$07
   tay
   clc
   lda offsets,y
   bpl @notnone
   jsr waitvblank
   jsr waitscreen
   jmp @exit
@notnone:
   sta NUSIZ0
   sta NUSIZ1
   and #$f0
   adc #40
   jsr spritepos
   inx
   clc
   lda offsets,y
   and #$f0
   adc #48
   jsr spritepos
   tya
   asl
   lda framecount
   lsr
   and #$0f
   tay
   sta WSYNC

   lda #$36
   jsr setcol
   
   lda #$20
   sta loopcount

   sta WSYNC
   jsr waitvblank

@twistloop:
   sta WSYNC
   bit TIMINT
   bmi @exit
   lda rotabar0,y
   sta GRP0
   lda rotabar1,y
   sta GRP1
   lda colu+0
   sta COLUP0
   lda colu+1
   sta COLUP1
   ldx loopcount
   lda sinustab,x
   asl
   asl
   asl
   asl
   and #$70
   clc
   adc #$36
   dey
   bpl @ok
   ldy #$0f
@ok:
   jsr setcol
   bit TIMINT
   bmi @exit
   clc
   lda loopcount
   asl
   asl
   tax
   lda sinustab,x
   ldx framecount
   adc sinustab,x
   lsr
   lsr
   lsr
   lsr
   tax
@delayloop:
   sta WSYNC
   bit TIMINT
   bmi @exit
   dex
   bpl @delayloop
   dec loopcount
   jmp @twistloop
   
@exit:
   lda #TIMER_OVERSCAN-2
   sta WSYNC
   jsr waitscreen+7
   sta WSYNC
   lda #$00
   sta GRP0
   sta GRP1
   jmp waitoverscan
