
.include "vcs.inc"
.include "globals.inc"


.define wait1 4
.define wait2 2

.macro AUDC value, channel
.local @channel
.ifnblank channel
@channel = channel
.else
@channel = 0
.endif
.byte $C0 | ( 2 * value ) | @channel
.endmacro

.macro AUDV value
.byte $80 | value
.endmacro

.macro AUDF value
.byte $A0 | value
.endmacro

.macro AUDW value
.byte value
.endmacro

.macro AUDB
.byte $90
.endmacro

.macro AUDE
.byte 0
.endmacro

.segment "RODATA"

song:
   .word @pattern00
   .word @pattern00
   .word @pattern00
   .word @pattern00

@songloop:
   .word @pattern01
   .word @pattern01
   .word @pattern01
   .word @pattern02

   .word 0
   

@pattern00:
   ; 3*note_g + 2*S
   AUDF 12
   AUDV 15
   AUDW wait1*3+wait2*2
   AUDV 0
   AUDW wait2
   
   ; note_g + -
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2
   
   ; note_g + D
   AUDF 26
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   ; note_g + -
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2

   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2

   ; note_ais + D + S
   AUDF 22
   AUDV 15
   AUDW wait1*2+wait2
   AUDV 0
   AUDW wait2
   
   ; note_ais + D
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2*2+wait1

   ; note_ais + D
   AUDF 22
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   AUDE

@pattern01:
   ; Note  gggg|-gg-|A-AA|AA-A
   ; oct   ----|-D--|--DD|D--D
   ; slide XX--|----|--X-|----
   
   ; 3*note_g + 2*S
   AUDF 12
   AUDV 15
   AUDW wait1*3+wait2*2
   AUDV 0
   AUDW wait2
   
   ; note_g + -
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2/2
   AUDB
   AUDW wait2/2
   AUDV 0
   AUDW wait1+wait2
   
   ; note_g + D
   AUDF 26
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   ; note_g + -
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2

   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2

   ; note_ais + D + S
   AUDF 22
   AUDV 15
   AUDW wait1*2+wait2
   AUDV 0
   AUDW wait2/2
   AUDB
   AUDW wait2/2

   ; note_ais + D
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2*2+wait1

   ; note_ais + D
   AUDF 22
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2

   AUDE

@pattern02:
   ; Note  gggg|-gg-|A-gA|gAgA
   ; oct   D---|-D--|--D-|D--D
   ; slide XX-X|----|--X-|----

.if 0
   ; note_g + D + S
   AUDF 26
   AUDV 15
   AUDW wait1+wait2
   
   ; note_g + s + note_g
   AUDF 12
   AUDW wait1+wait2+wait1
   AUDV 0
   AUDW wait2
   
   ; note_g
   AUDV 15
   AUDW wait1+wait2/2
   AUDB
   AUDW wait2/2
.else
   ; 3*note_g + 2*S
   AUDF 12
   AUDV 15
   AUDW wait1*3+wait2*2
   AUDV 0
   AUDW wait2
   
   ; note_g + -
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2/2
   AUDB
   AUDW wait2/2
.endif
   
   ; -
   AUDV 0
   AUDW wait1+wait2

   ; note_g + D
   AUDF 26
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2
   
   ; note_g + -
   AUDF 12
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2
   
   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2+wait1+wait2
   
   ; note_g + D + S
   AUDF 26
   AUDV 15
   AUDW wait1+wait2

   ; note_ais + -
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2/2
   AUDB
   AUDW wait2/2

   ; note_g + D
   AUDF 26
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2
   
   ; note_ais
   AUDF 10
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2
   
   ; note_g
   AUDF 12
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2
   
   ; note_ais + D
   AUDF 22
   AUDV 15
   AUDW wait1
   AUDV 0
   AUDW wait2
   
   AUDE
   
   ; oct   -UUU|--U-|U--U|-UU-
   

; useful values 1,3,6,7,8,14,15

; track format
; %00000000 end of pattern
; %0ddddddd delay in FPS
; %1000vvvv AUDV0/1 = %0000vvvv
; %110ccccx AUDCx   = %0000cccc
; %101fffff AUDF0/1 = %000fffff
; %10010000 BEAT

.segment "CODE"

bytetracker:
   dec trkdelay
   beq playdata
out:
   rts

reloop:
   cli
;   lda #$00
;   sta framecount
   lda #<(song+8)
   ldx #>(song+8)

bytetrackerset:
   sta songpos
   stx songpos+1
   lda #$01
   sta trkdelay
nextpat:
   lda audc2
   sta AUDC1
   sta audc
   lsr
   lsr
   lsr
   lsr
   sta AUDC0
   ldy #$00
   lda (songpos),y
   sta patpos
   iny
   lda (songpos),y
   beq reloop
   sta patpos+1
   clc
   lda #$02
   adc songpos
   sta songpos
   bcc playdata
   inc songpos+1
playdata:
   ldy #$00
   lda (patpos),y
   php
   inc patpos
   bne nopphi
   inc patpos+1
nopphi:
   plp
   bmi write    ; bit7:    AUDxx data
   beq nextpat  ; $00:     end of pattern
   sta trkdelay ; $01-$7f: delay
nopathi:
   rts

write:
   tay
   lda audv
   sta AUDV1
   lda audc
   sta AUDC1
   lda audf
   sta AUDF1
   tya
   and #$20
   bne write_f
   tya
   and #$40
   bne write_c
   tya
   and #$10
   bne beat
   
write_v:
   sty AUDV0
   sty AUDV1
   sty audv
   bpl playdata
   
beat:
   lda #$0f
   sta AUDV1
   lda #$08
   sta AUDC1
   lda #$03
   sta AUDF1
   bpl playdata
   
write_c:
   ldx #$00
   tya
   lsr
   bcc noc1
   inx
   sta audc
noc1:
   sta AUDC0,x
   bne playdata

write_f:
   sty AUDF0
   sty AUDF1
   sty audf
   bpl playdata
