
.include "vcs.inc"
.include "globals.inc"

; inspired by one small part of 4krawall
.define HEIGHT  $fe
.define XOFFSET $08

.segment "ZEROPAGE"

counter = localramstart+ 0
oldpos  = localramstart+ 1
temp    = localramstart+ 2
colstart= localramstart+ 3

.segment "CODE"

stripedprecalc:
   lda counter
   clc
   adc #$07
   sta counter
   
   inc colstart
   ldx counter ; startpos
   ldy colstart
   lda sinustab,y
   cpy #$40
   bcc @noneg1
   cpy #$c0
   bcs @noneg1
   eor #$ff
@noneg1:
   tay
   lda sinustab,x
   adc sinustab,y
   lsr
   lsr
   sta oldpos

   ldx #$00
   rts
   
striped1:
   jsr stripedprecalc
   lda #$27
   sta NUSIZ0
   sta NUSIZ1

   lda oldpos
   clc
   adc #$00 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$20 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$42 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$4a + XOFFSET
   jsr spritepos
   
   ldy #$aa
   bne stripdone

striped2:
   jsr stripedprecalc
   lda #$36
   sta NUSIZ0
   sta NUSIZ1
   
   lda oldpos
   clc
   adc #$00 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$10 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$41 + XOFFSET
   jsr spritepos
   inx
   lda oldpos
   clc
   adc #$51 + XOFFSET
   jsr spritepos

   ldy #$ff
   
stripdone:
   jsr waitvblank
   
   sty GRP0
   sty GRP1
   sty ENAM0
   sty ENAM1
   sta HMCLR
   sta WSYNC

   ldy colstart
   lda sinustab,y
   cpy #$40
   bcc @noneg2
   cpy #$c0
   bcs @noneg2
   eor #$ff
@noneg2:
   tay
   ldx counter
   sta WSYNC
   jsr delay12
   jsr delay12
@loop:
   lda sinustab,x
   adc sinustab,y
   lsr
   lsr
   sta temp
   sec
   eor #$ff
   adc oldpos
   asl
   asl
   asl
   asl
   sta HMP0
   sta HMP1
   sta HMM0
   sta HMM1
   lda temp
   sta oldpos
   lda paltab,y
;   sta WSYNC
   sta HMOVE
   sta COLUP0
   sta COLUP1
   txa
   adc #$03
   tax
   dey
   bit TIMINT
   bpl @loop
   
   lda #TIMER_OVERSCAN-1
   sta TIM64TI
   lda #$02
   sta VBLANK
   
   lda #$00
   sta GRP0
   sta GRP1
   sta ENAM0
   sta ENAM1
   sta COLUP0
   sta COLUP1

   jmp waitoverscan
