
.include "vcs.inc"
.include "globals.inc"

.define Y_OFFSET   0
.define COLORADD   $40
.define COLOREOR   $1E

.segment "ZEROPAGE"

frmcnt = localramstart+0
startx = localramstart+1
starty = localramstart+2
endy   = localramstart+3
counter= localramstart+4
bit08  = localramstart+5

.segment "RODATA"

p0add:
   .byte $04,$04,$1c
p1add:
   .byte $14,$0c,$24
m0add:
   .byte $45,$45,$2d
m1add:
   .byte $55,$4d,$35

.segment "CODE"

turning1:
   ldy #$00
   .byte $2c
turning2:
   ldy #$01
   .byte $2c
turning3:
   ldy #$02
   .byte $2c
turning4:
   ldy #$03

   lda #$08
   sta bit08
   inc framecount
   
   clc
   lda framecount
   and #$3f
   sta starty
   adc #$20
   sta endy
   
   lda starty
   and #$1f
   cmp #$10
   bcc @ok
   eor #$1f
@ok:
   sta startx
   
   ldx #$00
   lda startx
   clc
   adc p0add,y
   jsr spritepos
   
   inx
   lda startx
   clc
   adc p1add,y
   jsr spritepos
   
   inx
   lda startx
   clc
   adc m0add,y
   jsr spritepos
   
   inx
   lda startx
   clc
   adc m1add,y
   jsr spritepos
   
   jsr waitvblank
   sta HMCLR

   lda #$36
   sta NUSIZ0
   sta NUSIZ1
   
   lda #$00
   sta COLUP0
   lda #$00
   sta COLUP1
   
.if Y_OFFSET
   ldx #Y_OFFSET
@waitloop:
   dex
   sta WSYNC
   bne @waitloop
.endif

   sta WSYNC
   sta HMOVE
   lda #$ff
   sta GRP0
   sta GRP1
   sta ENAM0
   sta ENAM1

   ldy starty
   dey
   ldx #$07
   stx counter
   sta HMCLR
   bne @entry1a

@set00a:
   ldx #$00
   beq @skip2a

@loop1:
   tya            ; 2=24
   and #$0f       ; 2=26
   cmp #$0f       ; 2=28
   beq @set00a    ; 2=30
   tya            ; 2=32
   and #$1f       ; 2=34
   ldx #$f0       ; 2=36
   cmp #$10       ; 2=38
   bcc @skip2a    ; 2=40
   ldx #$10       ; 2=42
@skip2a:
   stx HMP0       ; 3=48
   stx HMP1       ; 3=51
   stx HMM0       ; 3=54
   stx HMM1       ; 3=57
@entry1a:
   tya            ; 2=59
   and #$3f       ; 2=61
   bit bit08      ; 3=64
   bne @skip3b    ; 2=66
   eor #$0f       ; 2=68
@skip3b:
   asl            ; 2=70
   adc #COLORADD  ; 2=72
   sta WSYNC      ; 3=75
   sta HMOVE      ; 3= 3
   sta COLUBK     ; 3= 6
   eor #COLOREOR  ; 2= 8
   sta COLUP0     ; 3=11
   sta COLUP1     ; 3=14
   iny            ; 2=16
   cpy endy       ; 3=19
   bne @loop1     ; 3=22
   
   dec counter
   beq @exit
   
   sta HMCLR
   sta WSYNC
   sta HMOVE

@loop2:
   dey
   tya
   and #$0f
   cmp #$0f
   beq @set00b
   tya
   and #$1f
   ldx #$10       ; 2=
   cmp #$10       ; 2=
   bcc @skip2b    ; 2=
   ldx #$f0       ; 2=
@skip2b:
   stx HMP0
   stx HMP1
   stx HMM0
   stx HMM1
   tya
   and #$3f
   bit bit08
   bne @skip3a
   eor #$0f
@skip3a:
   asl
   adc #COLORADD
   sta WSYNC
   sta HMOVE
   sta COLUBK
   eor #COLOREOR
   sta COLUP0
   sta COLUP1
   cpy starty
   bne @loop2
   
   dec counter
   beq @exit
   sta HMCLR
   sta WSYNC
   sta HMOVE
   jmp @loop1

@set00b:
   ldx #$00
   beq @skip2b

@exit:

   lda #$00
   sta WSYNC
   sta COLUBK
   sta GRP0
   sta GRP1
   sta ENAM0
   sta ENAM1

   jsr waitscreen
   jmp waitoverscan

